/*
**	LED-LC circuit
*/
#include "x.c"
#define W 500
#define H 500
#define y1 60
#define y2 300
#define y3 (H-6)
int Lpd= 0;
xdp(int a, int b) { XDrawPoint(dpy,w1,gc,a,b); }
xdl(int a, int b, int c, int d) { XDrawLine(dpy,w1,gc,a,b,c,d); }

main(argc,argv)
char **argv;
{
	double vcc, vc, vl, il, ic;
	double T= 0.25;	//micro second
	double L= 5;	//micro Henry
	double C= 50;	//micro Farad
	int i;
	iwt("LED-LC circuit",W,H);
	vcc= vc= ic= 0;
	for(i= 0; i< W; i++){
		if(i%100==0) {
			xdl(i,y1-5,i,y1+5);
			xdl(i,y2-5,i,y2+5);
			xdl(i,y3-5,i,y3+5);
			if(vcc>0)vcc= -0.3; else vcc= 12;
		}
		if(i&1){ xdp(i,y1); xdp(i,y2); xdp(i,y3); }
		vl= vcc - vc;
		if(Lpd && vl< -0.3) vl= -0.3;
		il+= vl*T/L;
		if(il<0) il= 0;
		if(Lpd && vl==-0.3) ic= 0; else ic= il;
		vc+= (ic - exp(vc - 10))*T/C;
		xdp(i,y1-4*vcc); xdp(i,y2-16*vc); xdp(i,y3-3*ic);
	}
	XFlush(dpy);
	printf("period=%6.3f\nPush Return key\n",2*M_PI*sqrt(L*C));
	getchar();
}
